summaryrefslogtreecommitdiffstats
path: root/system/fwupdate
diff options
context:
space:
mode:
author Andrew Clemons <andrew.clemons@gmail.com>2017-08-07 23:28:39 +0100
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2017-08-12 06:57:32 +0700
commite192b0c5fc3c8bfcfe082551519062b9b33a010d (patch)
treea0c8c08882bc7f888def62780ac1e51e4fdeec3b /system/fwupdate
parent5c6618414f54debe5b0523795f5061baea8f1faf (diff)
downloadslackbuilds-e192b0c5fc3c8bfcfe082551519062b9b33a010d.tar.gz
slackbuilds-e192b0c5fc3c8bfcfe082551519062b9b33a010d.tar.xz
system/fwupdate: Added (Tools to apply firmware updates).
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
Diffstat (limited to 'system/fwupdate')
-rw-r--r--system/fwupdate/README16
-rw-r--r--system/fwupdate/doinst.sh11
-rw-r--r--system/fwupdate/fwupdate.SlackBuild121
-rw-r--r--system/fwupdate/fwupdate.info10
-rw-r--r--system/fwupdate/slack-desc19
5 files changed, 177 insertions, 0 deletions
diff --git a/system/fwupdate/README b/system/fwupdate/README
new file mode 100644
index 0000000000..a3515433fb
--- /dev/null
+++ b/system/fwupdate/README
@@ -0,0 +1,16 @@
+fwupdate - Tools for using the ESRT and UpdateCapsule() to apply firmware
+updates
+
+The actual binary (fwup*.efi) is not automatically installed to your ESP.
+Copying it from /usr/libexec/fwupdate/ is left to be handled by the package
+admin.
+
+If you do not use the standard directory (/boot/efi/EFI/Slackware), you'll
+also need to adjust /usr/libexec/fwupdate/cleanup to cleanup the correct
+directory.
+
+I have not actually used this efi binary for anything yet. This package
+provides the libs needed by fwupd to update firmware, which is what I am
+using it for.
+
+The efi binary is included however for completeness.
diff --git a/system/fwupdate/doinst.sh b/system/fwupdate/doinst.sh
new file mode 100644
index 0000000000..e7c66a8cfc
--- /dev/null
+++ b/system/fwupdate/doinst.sh
@@ -0,0 +1,11 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ rm $NEW
+ fi
+}
+
+config usr/libexec/fwupdate/cleanup.new
diff --git a/system/fwupdate/fwupdate.SlackBuild b/system/fwupdate/fwupdate.SlackBuild
new file mode 100644
index 0000000000..50a421c977
--- /dev/null
+++ b/system/fwupdate/fwupdate.SlackBuild
@@ -0,0 +1,121 @@
+#!/bin/sh
+
+# Slackware build script for fwupdate
+
+# Copyright 2017 Andrew Clemons, Wellington New Zealand
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=fwupdate
+VERSION=${VERSION:-9}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+ EFIARCH=ia32
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+ EFIARCH=ia32
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+ EFIARCH=x64
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+make \
+ EFIDIR=Slackware \
+ libdir=/usr/lib$LIBDIRSUFFIX \
+ mandir=/usr/man \
+ datadir=/var/cache \
+ localedir=/usr/share/locale/
+
+make install \
+ DESTDIR=$PKG \
+ EFIDIR=Slackware \
+ libdir=/usr/lib$LIBDIRSUFFIX \
+ mandir=/usr/man \
+ datadir=/var/cache \
+ localedir=/usr/share/locale/
+
+mv $PKG/usr/libexec/fwupdate/cleanup $PKG/usr/libexec/fwupdate/cleanup.new
+
+rm -rf $PKG/usr/src
+
+if [ "$ARCH" = "x86_64" ]; then
+ rm -rf $PKG/usr/lib
+else
+ rm -rf $PKG/usr/lib/debug
+ rm -rf $PKG/usr/lib/systemd
+fi
+
+mv $PKG/boot/efi/EFI/Slackware/fwup* $PKG/usr/libexec/fwupdate/
+rm -rf $PKG/boot
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ COPYING TODO \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/fwupdate/fwupdate.info b/system/fwupdate/fwupdate.info
new file mode 100644
index 0000000000..a7eab8a8ea
--- /dev/null
+++ b/system/fwupdate/fwupdate.info
@@ -0,0 +1,10 @@
+PRGNAM="fwupdate"
+VERSION="9"
+HOMEPAGE="https://github.com/rhboot/fwupdate"
+DOWNLOAD="https://github.com/rhboot/fwupdate/archive/9/fwupdate-9.tar.gz"
+MD5SUM="0ce656b18a60256a7cf9fa42fd5d99de"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="efivar libsmbios"
+MAINTAINER="Andrew Clemons"
+EMAIL="andrew.clemons@gmail.com"
diff --git a/system/fwupdate/slack-desc b/system/fwupdate/slack-desc
new file mode 100644
index 0000000000..444c3879dd
--- /dev/null
+++ b/system/fwupdate/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+fwupdate: fwupdate (Tools to apply firmware updates)
+fwupdate:
+fwupdate: https://github.com/rhboot/fwupdate
+fwupdate:
+fwupdate:
+fwupdate:
+fwupdate:
+fwupdate:
+fwupdate:
+fwupdate:
+fwupdate: